﻿unit frmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, cxGraphics, cxControls,
  cxLookAndFeels, cxLookAndFeelPainters, cxContainer, cxEdit, cxLabel,
  cxTextEdit, cxMemo, Vcl.Menus, Vcl.StdCtrls, cxButtons,
  Spring.Collections, cxMaskEdit, cxSpinEdit;

type
  TForm1 = class(TForm)
    mmoLog: TcxMemo;
    lblCurrentPrime: TcxLabel;
    lblMaxGap: TcxLabel;
    cxLabel1: TcxLabel;
    cxLabel2: TcxLabel;
    btnPause: TcxButton;
    btnStart: TcxButton;
    edtFirst: TcxTextEdit;
    btnLeft: TcxButton;
    btnRight: TcxButton;
    btnSearch: TcxButton;
    edtSibiles: TcxTextEdit;
    lblSibiles: TcxLabel;
    lblSibilesAll: TcxLabel;
    btnParzyste: TcxButton;
    procedure FormCreate(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnPauseClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure btnRightClick(Sender: TObject);
    procedure btnLeftClick(Sender: TObject);
    procedure btnParzysteClick(Sender: TObject);
  private
    { Private declarations }
    fCurrentIndex: Integer;
    fMaxGap: Integer;
    fPrimes: IList<Integer>;
    fShortPrimesFile: TextFile;
    fLongPrimesFile: TextFile;
    fFlowFile: TextFile;
    fPureFlowFile: TextFile;
    fFlowReverseFile: TextFile;
    fFlowUPFile: TextFile;
    fFlowDownFile: TextFile;
    fOddsFile: TextFile;
    fOddIndex: Integer;
    fSearchBreak: boolean;
    procedure CalculateNextPrime();
    procedure CalculatePrimes();
    procedure CalculateOdds();
    procedure LoadPrimes(const aPrimesFileName: string);
    procedure SearchiSibilings(aFirstNumber: Integer);
    function SearchSibil(aFirstNumber: Integer): IList<Integer>;
    procedure WriteToFile(const aFile: TextFile; const aValue: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  System.StrUtils;


{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  fPrimes := TCollections.CreateList<Integer>;
  fMaxGap := 0;
  fCurrentIndex := 1;
  fOddIndex := 2;
  AssignFile(fShortPrimesFile, '.\ShortPrimes.txt');
  Rewrite(fShortPrimesFile);
  Writeln(fShortPrimesFile, 'Liczba pierwsza|Suma|Równowag');
  CloseFile(fShortPrimesFile);
  AssignFile(fLongPrimesFile, '.\LongPrimes.txt');
  Rewrite(fLongPrimesFile);
  Writeln(fLongPrimesFile, 'Liczba pierwsza|Suma|Równowag|Ciągi');
  CloseFile(fLongPrimesFile);
  AssignFile(fFlowFile, '.\FlowPrimes.txt');
  Rewrite(fFlowFile);
  Writeln(fFlowFile, 'Liczba pierwsza|Suma|Równowag|Flow');
  CloseFile(fFlowFile);
  AssignFile(fPureFlowFile, '.\FlowPurePrimes.txt');
  Rewrite(fPureFlowFile);
  CloseFile(fPureFlowFile);
  AssignFile(fFlowReverseFile, '.\FlowReversePrimes.txt');
  Rewrite(fFlowReverseFile);
  Writeln(fFlowReverseFile, 'Liczba pierwsza|Suma|Równowag|Flow');
  CloseFile(fFlowReverseFile);
  AssignFile(fFlowUPFile, '.\FlowUpPrimes.txt');
  Rewrite(fFlowUPFile);
  Writeln(fFlowUPFile, 'Liczba pierwsza|Suma|Równowag|Flow');
  CloseFile(fFlowUPFile);
  AssignFile(fFlowDownFile, '.\FlowDownPrimes.txt');
  Rewrite(fFlowDownFile);
  Writeln(fFlowDownFile, 'Liczba pierwsza|Suma|Równowag|Flow');
  CloseFile(fFlowDownFile);
  AssignFile(fOddsFile, '.\Odds.txt');
  Rewrite(fOddsFile);
end;

procedure TForm1.LoadPrimes(const aPrimesFileName: string);
var
  lPrimes: TextFile;
  lPrimeLine: String;
  lSplitted: TArray<String>;
  lPrime: string;
begin
  AssignFile(lPrimes, aPrimesFileName);
  Reset(lPrimes);
  While not EOF(lPrimes) do
  begin
    Readln(lPrimes, lPrimeLine);
    lSplitted := lPrimeLine.Split([' ']);
    for lPrime in lSplitted do
    begin
      if lPrime <> '' then
      begin
        fPrimes.Add(lPrime.ToInteger());
      end;
    end;
  end;
  CloseFile(lPrimes);

end;

procedure TForm1.btnStartClick(Sender: TObject);
begin
  btnStart.Enabled := False;
  mmoLog.Hide;
  if fPrimes.Count = 0 then
  begin
    lblCurrentPrime.Caption := 'wczytuję';
    Application.ProcessMessages;
    LoadPrimes('primes.txt');
  end;
  CalculatePrimes;
end;

procedure TForm1.CalculatePrimes();
begin
  While (not(btnPause.Down) and (fCurrentIndex < fPrimes.Count)) do
  begin
    CalculateNextPrime;
    inc(fCurrentIndex);
  end;
  mmoLog.Show;
end;

procedure TForm1.btnPauseClick(Sender: TObject);
begin
  btnStart.Enabled := true;
  btnParzyste.Enabled := true;
  mmoLog.Show;
end;

procedure TForm1.CalculateNextPrime();
var
  lCurrentPrime: Integer;
  lLocalCurrentIndex: Integer;
  lUpper: string;
  lLower: string;
  lUpperValue: integer;
  lLowerValue: integer;
  lEquals: Integer;
  lFlow, lFlowSign: string;
  s: string;

  procedure AddValue(aIndex: Integer);
  var
    lCurrentPrime: Integer;
    lSign: string;
  begin
    lCurrentPrime := fPrimes[aIndex];
    if lUpperValue <= lLowerValue then
    begin //na górę
      Inc(lUpperValue, lCurrentPrime);
      lUpper := lUpper + lCurrentPrime.ToString + ';';
      lFlow := lFlow + '^';
      if lUpperValue = lLowerValue then
      begin
        lFlowSign := lFlowSign + '=';
      end
      else
      begin
        lFlowSign := lFlowSign + '-';
      end;
    end
    else
    begin  //na dół
      Inc(lLowerValue, lCurrentPrime);
      lLower := lLower + lCurrentPrime.ToString + ';';
      lFlow := lFlow + 'v';
      lFlowSign := lFlowSign + '+';
    end;
    if lLowerValue = lUpperValue then
    begin
      inc(lEquals);
    end;
  end;
begin
  lCurrentPrime := fPrimes[fCurrentIndex];
  lblCurrentPrime.Caption := lCurrentPrime.ToString + ' (' + fCurrentIndex.ToString + '/' + fPrimes.Count.ToString + ')';

  lEquals := 0;
  lUpper := ''; lLower := '';
  lUpperValue := 0; lLowerValue := 0;
  lFlow := '';
  lFlowSign := '';

  for lLocalCurrentIndex := fCurrentIndex downto 0 do
  begin
    AddValue(lLocalCurrentIndex);
  end;

  if abs(lUpperValue - lLowerValue) > fMaxGap then
  begin
    fMaxGap := abs(lUpperValue - lLowerValue);
  end;

  s := Format('%15d|%4d|%8d', [lCurrentPrime, lUpperValue - lLowerValue, lEquals]);
  mmoLog.Lines.Add(s);
  WriteToFile(fShortPrimesFile, S);
//  s := Format('%15d|%4d|%8d', [fCurrentPrime, fUpperValue - fLowerValue, fEquals]);
  s := Format('%15d|%4d|%8d|%s', [lCurrentPrime, lUpperValue - lLowerValue, lEquals, lUpper]);
  WriteToFile(fLongPrimesFile, S);
  s := Format('%29s|%s', ['', lLower]);
  WriteToFile(fLongPrimesFile, S);

  s := Format('%15d|%4d|%8d|%s', [lCurrentPrime, lUpperValue - lLowerValue, lEquals, lFlowSign]);
  WriteToFile(fFlowFile, S);
  if lFlow.EndsWith('v') then
  begin //dwójka była na dole
    WriteToFile(fFlowDownFile, S);
  end
  else
  begin
    WriteToFile(fFlowUpFile, S);
  end;
  s := Format('%15d|%4d|%8d|%s', [lCurrentPrime, lUpperValue - lLowerValue, lEquals, ReverseString(lFlowSign)]);
  WriteToFile(fFlowReverseFile, s);
  s := Format('%29s|%s', ['', lFlow]);
  WriteToFile(fFlowFile, S);
  if lFlow.EndsWith('v') then
  begin //dwójka była na dole
    WriteToFile(fFlowDownFile, S);
  end
  else
  begin
    WriteToFile(fFlowUpFile, S);
  end;
  s := Format('%29s|%s', ['', ReverseString(lFlow)]);
  WriteToFile(fFlowReverseFile, s);
  WriteToFile(fPureFlowFile, ReverseString(lFlow));

  Application.ProcessMessages;
  lblMaxGap.Caption := fMaxGap.ToString;
end;

procedure TForm1.WriteToFile(const aFile: TextFile; const aValue: string);
begin
  Append(aFile);
  WriteLn(aFile, aValue);
  CloseFile(aFile);
end;

procedure TForm1.btnSearchClick(Sender: TObject);
var
  lFirstNumber: Integer;
  lText: string;
begin
  if btnSearch.SpeedButtonOptions.Down then
  begin
    fSearchBreak := false;
    lText := edtFirst.Text;
    If TryStrToInt(lText, lFirstNumber) then
    begin
      SearchiSibilings(lFirstNumber);
    end;
  end
  else
  begin
    fSearchBreak := true;
  end;
end;

procedure TForm1.SearchiSibilings(aFirstNumber: Integer);
var
  lSibiles: IList<Integer>;
  lSibilesTemp: IList<Integer>;
  lCurrentFirstNumber: Integer;
  S: String;
  lIndex: integer;
begin
//  lIndex := fPrimes.IndexOf(aFirstNumber);
//  While ((fSearchBreak = false) and (lIndex < fPrimes.Count)) do
//  begin
    lblSibiles.Caption := aFirstNumber.ToString;
    edtSibiles.Text := '';
    Application.ProcessMessages;
    lSibiles := SearchSibil(aFirstNumber);
    lblSibiles.Caption := aFirstNumber.ToString + '(' + lSibiles.Count.ToString + ')';

    S := '';
    for lCurrentFirstNumber in lSibiles do
    begin
       S := S + lCurrentFirstNumber.ToString +';';
    end;
    lblSibilesAll.Caption := S;

    lIndex := 0;
    for lCurrentFirstNumber in lSibiles do
    begin
      if fSearchBreak then
      begin
        Break;
      end;
      Application.ProcessMessages;
      lSibilesTemp := SearchSibil(lCurrentFirstNumber);
      edtSibiles.Text := edtSibiles.Text + lCurrentFirstNumber.ToString +'(' + lSibilesTemp.Count.ToString +');';
    end;
//  end;
end;

procedure TForm1.btnRightClick(Sender: TObject);
var
  lFirstNumber: Integer;
  lText: string;
  lIndex: Integer;
begin
  lText := edtFirst.Text;
  If TryStrToInt(lText, lFirstNumber) then
  begin
    lIndex := fPrimes.IndexOf(lFirstNumber);
    if (lIndex >= 0) and (lIndex < fPrimes.Count) then
    begin
      edtFirst.Text := fPrimes[succ(lIndex)].ToString;
    end;
  end;

end;

procedure TForm1.btnLeftClick(Sender: TObject);
var
  lFirstNumber: Integer;
  lText: string;
  lIndex: Integer;
begin
  lText := edtFirst.Text;
  If TryStrToInt(lText, lFirstNumber) then
  begin
    lIndex := fPrimes.IndexOf(lFirstNumber);
    if (lIndex > 0) then
    begin
      edtFirst.Text := fPrimes[pred(lIndex)].ToString;
    end;
  end;
end;

procedure TForm1.btnParzysteClick(Sender: TObject);
begin
  btnParzyste.Enabled := False;
  mmoLog.Hide;
  CalculateOdds;
end;

procedure TForm1.CalculateOdds();
var
  k: integer;
  S: string;
begin
  While (not(btnPause.Down)) do
  begin
    S := '';
    for k := 1 to 10 do
    begin
      S := S + ' ' + fOddIndex.ToString;
      inc(fOddIndex, 2);
    end;
    WriteToFile(fOddsFile, S);
    lblCurrentPrime.Caption := fOddIndex.ToString;
    Application.ProcessMessages;
  end;
  mmoLog.Show;
end;

function TForm1.SearchSibil(aFirstNumber: Integer): IList<Integer>;
var
  lIndex: Integer;
  lLine: string;
  k: integer;
  s: string;
  lPattern: string;
begin
  result := TCollections.CreateList<Integer>;
  lIndex := fPrimes.IndexOf(aFirstNumber);
  Reset(fPureFlowFile);

  for K := 0 to pred(lIndex) do
  begin
    Readln(fPureFlowFile, S);
  end;
  if fSearchBreak then
  begin
    Exit;
  end;

  lPattern := s;
  inc(lIndex);
  while not Eof(fPureFlowFile) do
  begin
    Application.ProcessMessages;
    Readln(fPureFlowFile, S);
    if s.StartsWith(lPattern) then
    begin
      result.Add(fPrimes[lIndex]);
    end;
    inc(lIndex);
  end;
  CloseFile(fPureFlowFile);
end;

end.
